/*
 *jQuery slidein v1.0
 *http://zxcvbnmnbvcxz.com
 *
 *Copyright 2012, kenta toshikura
 *
 *the MIT license.
 *http://www.opensource.org/licenses/mit-license.php 
*/

;(function($) {
    $.fn.slidein = function(option) {
        var element=this;

        dH = $(element).innerHeight();
        dW = $(element).innerWidth();

        var options = $.extend({
            intval: 1000,
            speed: 1000,
            vertical: 0,
            horizontal: 500,
            ease: 'easeInOutExpo',
            pointer: true,
            auto: true,
            reverse: false
        }, option);

        tgtNum = $(element).children().length;



        var first = $(element).children().first();
        var second = $(element).children().eq(1);
        var last = $(element).children().last();


        var arr = $.makeArray($(element).children());

        if(options.reverse){
        }else{
            arr.reverse();
        }

        $(arr).appendTo(element);


        $(element).css({
            'position':'relative',
            'height':dH,
            'width':dW,
            'overflow':'hidden'
        });

        $(element).children().css({
            'position':'absolute',
            'width':dW,
            'height':dH
        });

        $(element).wrap('<div class="slidein" style="position:relative; width:'+dW+'px; height:'+dH+'px;"></div>');
        $(element).after('<ul class="pageBd"><li class="next">next</li><li class="prev">prev</li></ul>');

        $('.slidein').css({
            'height':dH,
            'width':dW
        });

        if(options.pointer){
            animtept();
            $(element).parent().css({
                'overflow':'hidden'
            });
        }

        function animtept(){
            $('.pageBd li').css({
                'position':'absolute',
                'top':'50%',
                'height':'30px',
                'width':'30px',
                'text-indent':'-9999px',
                'display':'block',
                'cursor':'pointer'
            });
            $('.next').css({
                'right':'-30px',
                'margin-top':'-15px',
                'background':'url(images/goR.png) no-repeat'
            });
            $('.prev').css({
                'left':'-30px',
                'margin-top':'-15px',
                'background':'url(images/goL.png) no-repeat'
            });

            $('.slidein').hover(function(){
                $(this).find('.next').animate({'right':'15px'},500);
                $(this).find('.prev').animate({'left':'15px'},500);
            },function(){
                $(this).find('.next').animate({'right':'-30px'},500);
                $(this).find('.prev').animate({'left':'-30px'},500);
            });

        }

        if(tgtNum < 3){
            second.clone().appendTo(element);
            first.clone().appendTo(element);
            tgtNum = tgtNum + 2;
        }

        function anim () {
            first = $(element).children().first();
            last = $(element).children().last();
            last.not(':animated').delay(options.intval).animate({
                'opacity':'0',
                'margin-top':options.vertical,
                'margin-left':options.horizontal
            },
            {duration:options.speed,easing:options.ease,complete:
                function() {
                    last.prependTo(element);
                    $(element).children().not(':last').css({
                        'opacity':'1',
                        'margin-top':0,
                        'margin-left':0
                    });
                }
            });
        }

        function next () {
            first = $(element).children().first();
            last = $(element).children().last();
            last.not(':animated').animate({
                'opacity':'0',
                'margin-top':options.vertical,
                'margin-left':options.horizontal
            },
            {duration:options.speed,easing:options.ease,complete:
                function() {
                    last.prependTo(element);
                    first.css({
                        'opacity':'1',
                        'margin-top':0,
                        'margin-left':0
                    });
                }
            });
        }

        function prev () {
            first = $(element).children().first();
            first.css({
                'opacity':'0',
                'margin-top':options.vertical,
                'margin-left':options.horizontal
            }).appendTo(element);
            last = $(element).children().last();
            last.not(':animated').animate({
                'opacity':'1',
                'margin-top':0,
                'margin-left':0
            },options.speed);
        }

        if(options.auto){
            setInterval(function(){anim();},options.speed + options.intval);
        }

        $(element).next().find('.next').click(function(){
            next();
        });

        $(element).next().find('.prev').click(function(){
            prev();
        });

        return element;
    };
})(jQuery);